Index: cpukit/rtems/src/region.c
===================================================================
--- cpukit/rtems/src/region.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/rtems/src/region.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,48 +1,456 @@
-/**
- * @file
- *
- * @ingroup RTEMSImplClassicRegion
- *
- * @brief This source file contains a definition of the ::_Region_Information
- *   with zero objects.
- */
-
 /*
- * SPDX-License-Identifier: BSD-2-Clause
- *
- * Copyright (C) 2018 embedded brains GmbH & Co. KG
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
-
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
-
-#include <rtems/rtems/regiondata.h>
-
-OBJECTS_INFORMATION_DEFINE_ZERO(
-  _Region,
-  OBJECTS_CLASSIC_API,
-  OBJECTS_RTEMS_REGIONS,
-  OBJECTS_NO_STRING_NAME
-);
+ *  Region Manager
+ *
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/config.h>
+#include <rtems/object.h>
+#include <rtems/options.h>
+#include <rtems/region.h>
+#include <rtems/states.h>
+#include <rtems/thread.h>
+
+/*PAGE
+ *
+ *  _Region_Manager_initialization
+ *
+ *  This routine initializes all region manager related data structures.
+ *
+ *  Input parameters:
+ *    maximum_regions - number of regions to initialize
+ *
+ *  Output parameters:  NONE
+ */
+
+void _Region_Manager_initialization(
+  unsigned32 maximum_regions
+)
+{
+  _Objects_Initialize_information(
+     &_Region_Information,
+     FALSE,
+     maximum_regions,
+     sizeof( Region_Control )
+   );
+}
+
+/*PAGE
+ *
+ *  rtems_region_create
+ *
+ *  This directive creates a region of physical contiguous memory area
+ *  from which variable sized segments can be allocated.
+ *
+ *  Input parameters:
+ *    name             - user defined region name
+ *    starting_address - physical start address of region
+ *    length           - physical length in bytes
+ *    page_size        - page size in bytes
+ *    attribute_set    - region attributes
+ *    id               - address of region id to set
+ *
+ *  Output parameters:
+ *    id       - region id
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code - if unsuccessful
+ */
+
+rtems_status_code rtems_region_create(
+  Objects_Name        name,
+  void               *starting_address,
+  unsigned32          length,
+  unsigned32          page_size,
+  rtems_attribute  attribute_set,
+  Objects_Id         *id
+)
+{
+  Region_Control *the_region;
+
+  if ( !_Objects_Is_name_valid( name ) )
+    return ( RTEMS_INVALID_NAME );
+
+  if ( !_Addresses_Is_aligned( starting_address ) )
+    return( RTEMS_INVALID_ADDRESS );
+
+  _Thread_Disable_dispatch();             /* to prevent deletion */
+
+  the_region = _Region_Allocate();
+
+  if ( !the_region ) {
+    _Thread_Enable_dispatch();
+    return( RTEMS_TOO_MANY );
+  }
+
+  the_region->maximum_segment_size =
+    _Heap_Initialize(&the_region->Memory, starting_address, length, page_size);
+
+  if ( !the_region->maximum_segment_size ) {
+    _Region_Free( the_region );
+    _Thread_Enable_dispatch();
+    return( RTEMS_INVALID_SIZE );
+  }
+
+  the_region->starting_address      = starting_address;
+  the_region->length                = length;
+  the_region->page_size             = page_size;
+  the_region->attribute_set         = attribute_set;
+  the_region->number_of_used_blocks = 0;
+
+  _Thread_queue_Initialize(
+     &the_region->Wait_queue, attribute_set, STATES_WAITING_FOR_SEGMENT );
+
+  _Objects_Open( &_Region_Information, &the_region->Object, name );
+
+  *id = the_region->Object.id;
+  _Thread_Enable_dispatch();
+  return( RTEMS_SUCCESSFUL );
+}
+
+/*PAGE
+ *
+ *  rtems_region_ident
+ *
+ *  This directive returns the system ID associated with
+ *  the region name.
+ *
+ *  Input parameters:
+ *    name - user defined region name
+ *    id   - pointer to region id
+ *
+ *  Output parameters:
+ *    *id      - region id
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code - if unsuccessful
+ */
+
+rtems_status_code rtems_region_ident(
+  Objects_Name  name,
+  Objects_Id   *id
+)
+{
+  return _Objects_Name_to_id(
+      &_Region_Information,
+      name,
+      RTEMS_SEARCH_LOCAL_NODE,
+      id
+    );
+}
+
+/*PAGE
+ *
+ *  rtems_region_delete
+ *
+ *  This directive allows a thread to delete a region specified by
+ *  the region identifier, provided that none of its segments are
+ *  still allocated.
+ *
+ *  Input parameters:
+ *    id - region id
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code - if unsuccessful
+ */
+
+rtems_status_code rtems_region_delete(
+  Objects_Id id
+)
+{
+  register Region_Control *the_region;
+  Objects_Locations               location;
+
+  the_region = _Region_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:        /* this error cannot be returned */
+      return( RTEMS_INTERNAL_ERROR );
+    case OBJECTS_LOCAL:
+      _Region_Debug_Walk( the_region, 5 );
+      if ( the_region->number_of_used_blocks == 0 ) {
+        _Objects_Close( &_Region_Information, &the_region->Object );
+        _Region_Free( the_region );
+        _Thread_Enable_dispatch();
+        return( RTEMS_SUCCESSFUL );
+      }
+      _Thread_Enable_dispatch();
+      return( RTEMS_RESOURCE_IN_USE );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
+
+/*PAGE
+ *
+ *  rtems_region_extend
+ *
+ *  This directive attempts to grow a region of physical contiguous memory area
+ *  from which variable sized segments can be allocated.
+ *
+ *  Input parameters:
+ *    id         - id of region to grow
+ *    start      - starting address of memory area for extension
+ *    length     - physical length in bytes to grow the region
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code       - if unsuccessful
+ */
+
+rtems_status_code rtems_region_extend(
+  Objects_Id          id,
+  void               *starting_address,
+  unsigned32          length
+)
+{
+  Region_Control     *the_region;
+  Objects_Locations   location;
+  unsigned32          amount_extended;
+  Heap_Extend_status  heap_status;
+  rtems_status_code   status;
+
+  status = RTEMS_SUCCESSFUL;
+
+  the_region = _Region_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:        /* this error cannot be returned */
+      return( RTEMS_INTERNAL_ERROR );
+    case OBJECTS_LOCAL:
+
+      heap_status = _Heap_Extend(
+        &the_region->Memory,
+        starting_address,
+        length,
+        &amount_extended
+      );
+
+      switch ( heap_status ) {
+        case HEAP_EXTEND_SUCCESSFUL:
+          the_region->length                += amount_extended;
+          the_region->maximum_segment_size  += amount_extended;
+          break;
+        case HEAP_EXTEND_ERROR:
+          status = RTEMS_INVALID_ADDRESS;
+          break;
+        case HEAP_EXTEND_NOT_IMPLEMENTED:
+          status = RTEMS_NOT_IMPLEMENTED;
+          break;
+      }
+      _Thread_Enable_dispatch();
+      return( status );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );
+}
+
+/*PAGE
+ *
+ *  rtems_region_get_segment
+ *
+ *  This directive will obtain a segment from the given region.
+ *
+ *  Input parameters:
+ *    id         - region id
+ *    size       - segment size in bytes
+ *    option_set - wait option
+ *    timeout    - number of ticks to wait (0 means wait forever)
+ *    segment    - pointer to segment address
+ *
+ *  Output parameters:
+ *    segment    - pointer to segment address filled in
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code - if unsuccessful
+ */
+
+rtems_status_code rtems_region_get_segment(
+  Objects_Id         id,
+  unsigned32         size,
+  rtems_option    option_set,
+  rtems_interval  timeout,
+  void              **segment
+)
+{
+  register Region_Control *the_region;
+  Objects_Locations        location;
+  Thread_Control          *executing;
+  void                    *the_segment;
+
+  if ( size == 0 )
+    return( RTEMS_INVALID_SIZE );
+
+  executing  = _Thread_Executing;
+  the_region = _Region_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:        /* this error cannot be returned */
+      return( RTEMS_INTERNAL_ERROR );
+    case OBJECTS_LOCAL:
+      if ( size > the_region->maximum_segment_size ) {
+        _Thread_Enable_dispatch();
+        return( RTEMS_INVALID_SIZE );
+      }
+
+      _Region_Debug_Walk( the_region, 1 );
+
+      the_segment = _Region_Allocate_segment( the_region, size );
+
+      _Region_Debug_Walk( the_region, 2 );
+
+      if ( the_segment ) {
+        the_region->number_of_used_blocks += 1;
+        _Thread_Enable_dispatch();
+        *segment = the_segment;
+        return( RTEMS_SUCCESSFUL );
+      }
+
+      if ( _Options_Is_no_wait( option_set ) ) {
+        _Thread_Enable_dispatch();
+        return( RTEMS_UNSATISFIED );
+      }
+
+      executing->Wait.queue              = &the_region->Wait_queue;
+      executing->Wait.id                 = id;
+      executing->Wait.Extra.segment_size = size;
+      executing->Wait.return_argument    = (unsigned32 *) segment;
+
+      the_region->Wait_queue.sync = TRUE;
+
+      _Thread_queue_Enqueue( &the_region->Wait_queue, timeout );
+
+      _Thread_Enable_dispatch();
+      return( executing->Wait.return_code );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
+/*PAGE
+ *
+ *  rtems_region_get_segment_size
+ *
+ *  This directive will return the size of the segment indicated
+ *
+ *  Input parameters:
+ *    id         - region id
+ *    segment    - segment address
+ *    size       - pointer to segment size in bytes
+ *
+ *  Output parameters:
+ *    size       - segment size in bytes filled in
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code - if unsuccessful
+ */
+
+rtems_status_code rtems_region_get_segment_size(
+  Objects_Id         id,
+  void              *segment,
+  unsigned32        *size
+)
+{
+  register Region_Control *the_region;
+  Objects_Locations        location;
+  Thread_Control          *executing;
+
+  executing  = _Thread_Executing;
+  the_region = _Region_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:        /* this error cannot be returned */
+      return( RTEMS_INTERNAL_ERROR );
+    case OBJECTS_LOCAL:
+
+      if ( _Heap_Size_of_user_area( &the_region->Memory, segment, size ) ) {
+        _Thread_Enable_dispatch();
+        return( RTEMS_SUCCESSFUL );
+      }
+      _Thread_Enable_dispatch();
+      return( RTEMS_INVALID_ADDRESS );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
+
+/*PAGE
+ *
+ *  rtems_region_return_segment
+ *
+ *  This directive will return a segment to its region.
+ *
+ *  Input parameters:
+ *    id      - region id
+ *    segment - pointer to segment address
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_region_return_segment(
+  Objects_Id  id,
+  void       *segment
+)
+{
+  register Region_Control *the_region;
+  Thread_Control          *the_thread;
+  Objects_Locations        location;
+  void                   **the_segment;
+  int                      status;
+
+  the_region = _Region_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:        /* this error cannot be returned */
+      return( RTEMS_INTERNAL_ERROR );
+    case OBJECTS_LOCAL:
+
+      _Region_Debug_Walk( the_region, 3 );
+
+      status = _Region_Free_segment( the_region, segment );
+
+      _Region_Debug_Walk( the_region, 4 );
+
+      if ( !status ) {
+        _Thread_Enable_dispatch();
+        return( RTEMS_INVALID_ADDRESS );
+      }
+
+      the_region->number_of_used_blocks -= 1;
+      for ( ; ; ) {
+        the_thread = _Thread_queue_First( &the_region->Wait_queue );
+
+        if ( the_thread == NULL )
+           break;
+
+        the_segment = _Region_Allocate_segment(
+                        the_region, the_thread->Wait.Extra.segment_size );
+
+        if ( the_segment == NULL )
+           break;
+
+        *(void **)the_thread->Wait.return_argument = the_segment;
+        the_region->number_of_used_blocks += 1;
+        _Thread_queue_Extract( &the_region->Wait_queue, the_thread );
+        the_thread->Wait.return_code = RTEMS_SUCCESSFUL;
+      }
+
+      _Thread_Enable_dispatch();
+      return( RTEMS_SUCCESSFUL );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
Index: cpukit/rtems/src/regionmp.c
===================================================================
--- cpukit/rtems/src/regionmp.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
+++ cpukit/rtems/src/regionmp.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -0,0 +1,308 @@
+/*
+ *  Multiprocessing Support for the Region Manager
+ *
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/mpci.h>
+#include <rtems/mppkt.h>
+#include <rtems/object.h>
+#include <rtems/options.h>
+#include <rtems/region.h>
+#include <rtems/thread.h>
+
+/*PAGE
+ *
+ *  _Region_MP_Send_process_packet
+ *
+ */
+
+void _Region_MP_Send_process_packet (
+  Region_MP_Remote_operations  operation,
+  Objects_Id                      region_id,
+  Objects_Name                    name,
+  Objects_Id                      proxy_id
+)
+{
+  Region_MP_Packet *the_packet;
+  unsigned32           node;
+
+  switch ( operation ) {
+
+    case REGION_MP_ANNOUNCE_CREATE:
+    case REGION_MP_ANNOUNCE_DELETE:
+    case REGION_MP_EXTRACT_PROXY:
+
+      the_packet                    = _Region_MP_Get_packet();
+      the_packet->Prefix.the_class  = RTEMS_MP_PACKET_REGION;
+      the_packet->Prefix.length     = sizeof ( Region_MP_Packet );
+      the_packet->Prefix.to_convert = sizeof ( Region_MP_Packet );
+      the_packet->operation         = operation;
+      the_packet->Prefix.id         = region_id;
+      the_packet->name              = name;
+      the_packet->proxy_id          = proxy_id;
+
+      if ( operation == REGION_MP_EXTRACT_PROXY )
+         node = rtems_get_node( region_id );
+      else
+         node = MPCI_ALL_NODES;
+
+      _MPCI_Send_process_packet( node, &the_packet->Prefix );
+      break;
+
+    case REGION_MP_GET_SEGMENT_REQUEST:
+    case REGION_MP_GET_SEGMENT_RESPONSE:
+    case REGION_MP_RETURN_SEGMENT_REQUEST:
+    case REGION_MP_RETURN_SEGMENT_RESPONSE:
+      break;
+  }
+}
+
+/*PAGE
+ *
+ *  _Region_MP_Send_request_packet
+ *
+ */
+
+rtems_status_code _Region_MP_Send_request_packet (
+  Region_MP_Remote_operations  operation,
+  Objects_Id                   region_id,
+  void                        *segment,
+  unsigned32                   size,
+  rtems_option              option_set,
+  rtems_interval            timeout
+)
+{
+  Region_MP_Packet *the_packet;
+
+  switch ( operation ) {
+
+    case REGION_MP_GET_SEGMENT_REQUEST:
+    case REGION_MP_RETURN_SEGMENT_REQUEST:
+
+      the_packet                    = _Region_MP_Get_packet();
+      the_packet->Prefix.the_class  = RTEMS_MP_PACKET_REGION;
+      the_packet->Prefix.length     = sizeof ( Region_MP_Packet );
+      the_packet->Prefix.to_convert = sizeof ( Region_MP_Packet );
+      if ( ! _Options_Is_no_wait(option_set))
+          the_packet->Prefix.timeout = timeout;
+
+      the_packet->operation         = operation;
+      the_packet->Prefix.id         = region_id;
+      the_packet->segment           = segment;
+      the_packet->size              = size;
+      the_packet->option_set        = option_set;
+
+      return _MPCI_Send_request_packet(
+          rtems_get_node( region_id ),
+          &the_packet->Prefix,
+          STATES_READY      /* Not used */
+        );
+      break;
+
+    case REGION_MP_ANNOUNCE_CREATE:
+    case REGION_MP_ANNOUNCE_DELETE:
+    case REGION_MP_EXTRACT_PROXY:
+    case REGION_MP_GET_SEGMENT_RESPONSE:
+    case REGION_MP_RETURN_SEGMENT_RESPONSE:
+      break;
+
+  }
+  /*
+   *  The following line is included to satisfy compilers which
+   *  produce warnings when a function does not end with a return.
+   */
+  return RTEMS_INTERNAL_ERROR;
+}
+
+/*PAGE
+ *
+ *  _Region_MP_Send_response_packet
+ *
+ */
+
+void _Region_MP_Send_response_packet (
+  Region_MP_Remote_operations  operation,
+  Objects_Id                   region_id,
+  Thread_Control              *the_thread
+)
+{
+  Region_MP_Packet *the_packet;
+
+  switch ( operation ) {
+
+    case REGION_MP_GET_SEGMENT_RESPONSE:
+    case REGION_MP_RETURN_SEGMENT_RESPONSE:
+
+      the_packet = ( Region_MP_Packet *) the_thread->receive_packet;
+
+/*
+ *  The packet being returned already contains the class, length, and
+ *  to_convert fields, therefore they are not set in this routine.
+ */
+      the_packet->operation = operation;
+      the_packet->Prefix.id = the_packet->Prefix.source_tid;
+
+      _MPCI_Send_response_packet(
+        rtems_get_node( the_packet->Prefix.source_tid ),
+        &the_packet->Prefix
+      );
+      break;
+
+    case REGION_MP_ANNOUNCE_CREATE:
+    case REGION_MP_ANNOUNCE_DELETE:
+    case REGION_MP_EXTRACT_PROXY:
+    case REGION_MP_GET_SEGMENT_REQUEST:
+    case REGION_MP_RETURN_SEGMENT_REQUEST:
+      break;
+
+  }
+}
+
+/*PAGE
+ *
+ *
+ *  _Region_MP_Process_packet
+ *
+ */
+
+void _Region_MP_Process_packet (
+  rtems_packet_prefix  *the_packet_prefix
+)
+{
+  Region_MP_Packet *the_packet;
+  Thread_Control   *the_thread;
+  boolean           ignored;
+
+  the_packet = (Region_MP_Packet *) the_packet_prefix;
+
+  switch ( the_packet->operation ) {
+
+    case REGION_MP_ANNOUNCE_CREATE:
+
+      ignored = _Objects_MP_Open(
+                  &_Region_Information,
+                  the_packet->name,
+                  the_packet->Prefix.id,
+                  TRUE
+                );
+
+      _MPCI_Return_packet( the_packet_prefix );
+      break;
+
+    case REGION_MP_ANNOUNCE_DELETE:
+
+      _Objects_MP_Close( &_Region_Information, the_packet->Prefix.id );
+
+      _MPCI_Return_packet( the_packet_prefix );
+      break;
+
+    case REGION_MP_EXTRACT_PROXY:
+
+      the_thread = _Thread_MP_Find_proxy( the_packet->proxy_id );
+
+      if ( ! _Thread_Is_null( the_thread ) )
+        _Thread_queue_Extract( the_thread->Wait.queue, the_thread );
+
+      _MPCI_Return_packet( the_packet_prefix );
+      break;
+
+    case REGION_MP_GET_SEGMENT_REQUEST:
+
+      the_packet->Prefix.return_code = rtems_region_get_segment(
+        the_packet->Prefix.id,
+        the_packet->size,
+        the_packet->option_set,
+        the_packet->Prefix.timeout,
+        &the_packet->segment
+      );
+
+      _Region_MP_Send_response_packet(
+        REGION_MP_GET_SEGMENT_RESPONSE,
+        the_packet->Prefix.id,
+        _Thread_Executing
+      );
+      break;
+
+    case REGION_MP_GET_SEGMENT_RESPONSE:
+
+      the_thread = _MPCI_Process_response( the_packet_prefix );
+
+      *(void **)the_thread->Wait.return_argument = the_packet->segment;
+
+      _MPCI_Return_packet( the_packet_prefix );
+      break;
+
+    case REGION_MP_RETURN_SEGMENT_REQUEST:
+
+      the_packet->Prefix.return_code = rtems_region_return_segment(
+        the_packet->Prefix.id,
+        the_packet->segment
+      );
+
+      _Region_MP_Send_response_packet(
+        REGION_MP_RETURN_SEGMENT_RESPONSE,
+        the_packet->Prefix.id,
+        _Thread_Executing
+      );
+      break;
+
+    case REGION_MP_RETURN_SEGMENT_RESPONSE:
+
+      the_thread = _MPCI_Process_response( the_packet_prefix );
+
+      _MPCI_Return_packet( the_packet_prefix );
+      break;
+
+  }
+}
+
+/*PAGE
+ *
+ *  _Region_MP_Send_object_was_deleted
+ *
+ *  This routine is not needed by the Region since a region
+ *  cannot be deleted when segments are in use.
+ *
+ */
+
+/*PAGE
+ *
+ *  _Region_MP_Send_extract_proxy
+ *
+ */
+
+void _Region_MP_Send_extract_proxy (
+  Thread_Control *the_thread
+)
+{
+  _Region_MP_Send_process_packet(
+    REGION_MP_EXTRACT_PROXY,
+    the_thread->Wait.id,
+    (Objects_Name) 0,
+    the_thread->Object.id
+  );
+}
+
+/*PAGE
+ *
+ *  _Region_MP_Get_packet
+ *
+ */
+
+Region_MP_Packet *_Region_MP_Get_packet ( void )
+{
+  return ( (Region_MP_Packet *) _MPCI_Get_packet() );
+}
+
+/* end of file */
Index: cpukit/rtems/src/rtclock.c
===================================================================
--- cpukit/rtems/src/rtclock.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
+++ cpukit/rtems/src/rtclock.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -0,0 +1,153 @@
+/*
+ *  Clock Manager
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/clock.h>
+#include <rtems/config.h>
+#include <rtems/isr.h>
+#include <rtems/thread.h>
+#include <rtems/tod.h>
+#include <rtems/watchdog.h>
+
+/*PAGE
+ *
+ *  rtems_clock_get
+ *
+ *  This directive returns the current date and time.  If the time has
+ *  not been set by a tm_set then an error is returned.
+ *
+ *  Input parameters:
+ *    option      - which value to return
+ *    time_buffer - pointer to output buffer (a time and date structure
+ *                  or an interval)
+ *
+ *  Output parameters:
+ *    time_buffer      - output filled in
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code       - if unsuccessful
+ */
+
+rtems_status_code rtems_clock_get(
+  rtems_clock_get_options  option,
+  void                    *time_buffer
+)
+{
+  ISR_Level      level;
+  rtems_interval tmp;
+
+  switch ( option ) {
+    case RTEMS_CLOCK_GET_TOD:
+      if ( !_TOD_Is_set() )
+        return( RTEMS_NOT_DEFINED );
+
+      *(rtems_time_of_day *)time_buffer = _TOD_Current;
+      return( RTEMS_SUCCESSFUL );
+
+    case RTEMS_CLOCK_GET_SECONDS_SINCE_EPOCH:
+      if ( !_TOD_Is_set() )
+        return( RTEMS_NOT_DEFINED );
+
+      *(rtems_interval *)time_buffer = _TOD_Seconds_since_epoch;
+      return( RTEMS_SUCCESSFUL );
+
+    case RTEMS_CLOCK_GET_TICKS_SINCE_BOOT:
+      *(rtems_interval *)time_buffer = _TOD_Ticks_since_boot;
+      return( RTEMS_SUCCESSFUL );
+
+    case RTEMS_CLOCK_GET_TICKS_PER_SECOND:
+      *(rtems_interval *)time_buffer = _TOD_Ticks_per_second;
+      return( RTEMS_SUCCESSFUL );
+
+    case RTEMS_CLOCK_GET_TIME_VALUE:
+      if ( !_TOD_Is_set() )
+        return( RTEMS_NOT_DEFINED );
+
+      _ISR_Disable( level );
+        ((rtems_clock_time_value *)time_buffer)->seconds =
+          _TOD_Seconds_since_epoch;
+        tmp = _TOD_Current.ticks;
+      _ISR_Enable( level );
+
+      tmp *= _Configuration_Table->microseconds_per_tick;
+      ((rtems_clock_time_value *)time_buffer)->microseconds = tmp;
+
+      return( RTEMS_SUCCESSFUL );
+  }
+
+  return( RTEMS_SUCCESSFUL );   /* should never get here */
+
+}
+
+/*PAGE
+ *
+ *  rtems_clock_set
+ *
+ *  This directive sets the date and time for this node.
+ *
+ *  Input parameters:
+ *    time_buffer - pointer to the time and date structure
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_clock_set(
+  rtems_time_of_day *time_buffer
+)
+{
+  rtems_status_code      local_result;
+  rtems_interval seconds;
+
+  local_result = _TOD_Validate( time_buffer );
+  if ( rtems_is_status_successful( local_result ) ) {
+    seconds = _TOD_To_seconds( time_buffer );
+    _Thread_Disable_dispatch();
+      _TOD_Set( time_buffer, seconds );
+    _Thread_Enable_dispatch();
+
+  }
+  return( local_result );
+}
+
+/*PAGE
+ *
+ *  rtems_clock_tick
+ *
+ *  This directive notifies the executve that a tick has occurred.
+ *  When the tick occurs the time manager updates and maintains
+ *  the calendar time, timeslicing, and any timeout delays.
+ *
+ *  Input parameters:  NONE
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - always succeeds
+ *
+ *  NOTE: This routine only works for leap-years through 2099.
+ */
+
+rtems_status_code rtems_clock_tick( void )
+{
+  _TOD_Tickle_ticks();
+
+  _Watchdog_Tickle_ticks();
+
+  _Thread_Tickle_timeslice();
+
+  if ( _Thread_Is_context_switch_necessary() &&
+       _Thread_Is_dispatching_enabled() )
+    _Thread_Dispatch();
+
+  return( RTEMS_SUCCESSFUL );
+}
